﻿Rem
bbdoc:   TButton
returns: :Tbutton
End Rem
Type TButton Extends Gadget
	Field Vather:twindow, Press:Int, Typ:Int, Tile:Int, Image:TImage

	Method Draw(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
		Local A:Float = GetAlpha()
		
		If Typ = 0 Then
			SetBlend ALPHABLEND
			SetAlpha 1
			
			If Activ = 0 Then
				SetColor R, G, B
				DrawLine DX, DY + 1, DX, DY + H - 1
				DrawLine DX, DY, DX + W, DY
				
				SetColor 50, 50, 50
				DrawLine DX, DY + H, DX + W, DY + H
				DrawLine DX + W, DY, DX + W, DY + H - 1
				
				SetColor 0, 0, 0
				SetAlpha 0.35
				DrawRect DX + 1, DY + 1, W - 1, H - 1
			Else
				SetColor 50, 50, 50
				DrawLine DX, DY + 1, DX, DY + H - 1
				DrawLine DX, DY, DX + W, DY
				
				SetColor R, G, B
				DrawLine DX, DY + H, DX + W, DY + H
				DrawLine DX + W, DY, DX + W, DY + H - 1
				
				SetColor 0, 0, 0
				SetAlpha 0.35
				DrawRect DX + 1, DY + 1, W - 1, H - 1
			End If
			SetViewport DX + 1, DY + 1, W - 1, H - 1
			GuiText Text, DX + (W - 1) / 2 - (TextWidth(Text) - 1) / 2, DY + H / 2 - Gadget.TH / 2, R, G, B
			SetViewport 0, 0, GraphicsWidth(), GraphicsHeight()
		EndIf
		
		If Typ = 1 Then
			SetColor R, G, B
			SetAlpha 1
			If Image Then DrawImage Image, DX, DY, Tile
		End If
			
		SetColor 255, 255, 255
		SetAlpha A
		
	End Method
	
	Method Update:Int(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
				
		If Vather = Null Then
			If Over() = 0 Then
				If GetMouse(DX, DY, W, H) = 1 Then
					Activ = 1
					If MouseDown(1) Then Press = 1 FlushMouse() Return 1
				Else
					Activ = 0
				EndIf
			Else
				Activ = 0
			EndIf
		Else
			If GetMouse(DX, DY, W, H) = 1 Then
				Activ = 1
				If MouseDown(1) Then Press = 1 FlushMouse() Return 1
			Else
				Activ = 0
			EndIf
		EndIf
		
	End Method
	
	Rem
	bbdoc:   Tile eines ImageButton ändern (Tile muss vorhanden sein.)
	returns: -
	End Rem
	Method SetTile(Tile:Int)
		Self.Tile = Tile
	End Method
	
	Rem
	bbdoc:   Ein Image dem Button zuweisen (vorsicht grössenänderung des Buttons automatisiert)
	returns: -
	End Rem
	Method SetImage(I:TImage)
		If Self.Typ = 1 Then
			Self.Image = I
			If Self.Image Then
				Self.W = Self.Image.width
				Self.H = Self.Image.height
			End If
		End If
	End Method
End Type

Rem
bbdoc:   Erstellt ein Button (Text:String, X:Int, Y:Int, W:Int, H:Int, Win:TWindow = Null)
returns: :TButton
End Rem
Function NewButton:TButton (Text:String, X:Int, Y:Int, W:Int, H:Int, Win:TWindow = Null)
	Local B:TButton = New TButton
	B.X = X
	B.Y = Y
	B.W = W
	B.H = H
	B.Text = Text
	B.Vather = win
	B.SetStandart
	
	If win = Null Then
		Gadget.List.AddLast B
	Else
		win.Inhalt.AddLast B
	End If
	Return B
End Function

Rem
bbdoc:   Gibt aus ob der Button nun Gedrückt wurde, wenn ja Rückgabe=1 andernfalls 0
returns: :Int
End Rem
Function ButtonPress:Int(B:TButton)
	If B Then
		Local P:Int = b.Press
		B.Press = 0
		Return P
	End If
End Function

Rem
bbdoc:   Wenn die Maus sich auf dem Button befindet wird eine 1 zurückgegeben
returns: :Int
End Rem
Function ButtonOver:Int(B:TButton)
	If B Then
		Return B.Activ
	End If
End Function

Rem
bbdoc:   Ein Bild als Button (Image:TImage, Tile:Int, X:Int, Y:Int, Win:TWindow = Null) <br>Ohne Bild angabe existiert kein Button!
returns: :TButton
End Rem
Function NewImageButton:TButton (Image:TImage, Tile:Int, X:Int, Y:Int, Win:TWindow = Null)
	Local B:TButton = New TButton
	B.Typ = 1
	B.Image = Image
	B.Tile = Tile
	B.W = B.Image.width
	B.H = B.Image.height
	B.X = X
	B.Y = Y
	
	B.R = 255
	B.G = 255
	B.B = 255
	
	B.Vather = win
	
	If Win = Null Then
		Gadget.List.AddLast B
	Else
		win.Inhalt.AddLast B
	End If
	Return B
End Function