﻿SuperStrict
Import brl.GLMax2D
Import BRL.PolledInput
Import brl.FreeTypeFont

Rem 
bbdoc: MaxBase - Gui 
End Rem 
Module maxbase.gui
ModuleInfo "Version: 1.02" 
ModuleInfo "Author: Mathias Kwiatkowski" 
ModuleInfo "License: © by MaxBase"
ModuleInfo "History: 1.00 Offizielle Alpha"
ModuleInfo "History: 1.01 ADD - Window"

Rem 
bbdoc:   Gadget
returns: Gadget
End Rem
Type Gadget Abstract
	Global List:TList = New TList
	Global StandartR:Int = 255
	Global StandartG:Int = 255
	Global StandartB:Int = 255
	
	Global TH:Int
	
	Field R:Int, G:Int, B:Int, Inhalt:TList
	Field X:Int, Y:Int, W:Int, H:Int, Text:String, Activ:Int
		
	Rem
	bbdoc:   Ermittelt Innere Werte des Objekts (Fenster ohne Rahmen) Weite
	returns: :Int
	End Rem
	Method ClientW:Int()
		Local ViewW:Int = w - 1
		Local ViewH:Int = h - 1 - 3 - gadget.TH
		Return ViewW
	End Method
	
	Rem
	bbdoc:   Ermittelt Innere Werte des Objekts (Fenster ohne Rahmen) Hohe
	returns: :Int
	End Rem
	Method ClientH:Int()
		Local ViewW:Int = w - 1
		Local ViewH:Int = h - 1 - 3 - gadget.TH
		Return ViewH
	End Method
	
	Rem
	bbdoc:   Setzt das Objekt auf X Achse
	returns: -
	End Rem
	Method SetX(X:Int)
		Self.X = X
	End Method
	
	Rem
	bbdoc:   Setzt das Objekt auf Y Achse
	returns: -
	End Rem
	Method SetY(Y:Int)
		Self.Y = Y
	End Method
	
	Rem
	bbdoc:   Setzt die Weite des Objekts 
	returns: -
	End Rem
	Method SetW(W:Int)
		Self.W = W
	End Method
	
	Rem
	bbdoc:   Setzt die Höhe des Objekts 
	returns: -
	End Rem
	Method SetH(H:Int)
		Self.H = H
	End Method
	
	Rem
	bbdoc:   Ermittelt die X Achse
	returns: :Int
	End Rem
	Method GetX:Int()
		Return X
	End Method
	
	Rem
	bbdoc:   Ermittelt die Y Achse
	returns: :Int
	End Rem
	Method GetY:Int()
		Return Y
	End Method
	
	Rem
	bbdoc:   Ermittelt die Weite des Objekts
	returns: :Int
	End Rem
	Method GetW:Int()
		Return W
	End Method
	
	Rem
	bbdoc:   Ermittelt die Höhe des Objekts
	returns: :Int
	End Rem
	Method GetH:Int()
		Return H
	End Method
	
	Rem
	bbdoc:   Setzt das Objekt Text z.b. Window Title
	returns: -
	End Rem
	Method SetTitle(Text:String)
		Text = Text
	End Method
	
	Rem
	bbdoc:   Ermittelt vom Objekt den Text
	returns: -
	End Rem
	Method GetTitle:String()
		Return Text
	End Method
	
	Rem
	bbdoc:   Setzt Farbwerte für das Objekt (R,G,B)
	returns: -
	End Rem
	Method Color(R:Int, G:Int, B:Int)
		Self.R = R
		Self.G = G
		Self.B = B
	End Method
	
	Method SetStandart()
		Self.Color (Gadget.StandartR, Gadget.StandartG, Gadget.StandartB)
	End Method
	
	Method Draw(SX:Int = 0, SY:Int = 0) Abstract
	
	Method Update:Int(SX:Int = 0, SY:Int = 0) Abstract
	
	Method Over:Int()
		Local Auf:Int = 0
		For Local O:Object = EachIn Gadget.List
			If TWindow(O) Then
				If GetMouse(TWindow(O).X, TWindow(O).Y, TWindow(O).W, TWindow(O).H) = 1 Then Auf = 1 Return 1
			End If
		Next
	End Method
End Type

Rem
bbdoc:   Setzt Standart Farbwerte für alle Objekte (R,G,B)
returns: -
End Rem
Function SetGuiColor(R:Int, G:Int, B:Int)
	Gadget.StandartR = R
	Gadget.StandartG = G
	Gadget.StandartB = B
End Function

Rem
bbdoc:   TWindow
returns: :TWindow
End Rem
Type TWindow Extends Gadget
	Field Move:Int, TX:Int, TY:Int, Closeable:Int
	
	Method Draw(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
		Local A:Float = GetAlpha()
		SetBlend ALPHABLEND
		SetColor R, G, B
		SetAlpha 1
		
		SetAlpha 0.9
		SetColor 50, 50, 50
		Rect DX, DY, W, H, 1
		SetAlpha 0.2
		SetColor R, G, B
		Rect DX, DY, W, H, 1
		
		SetAlpha 1
		
		Rect DX, DY, W, H
		
		DrawLine DX + 1, DY + TH + 2, DX + 1 + W - 1, DY + TH + 2
		
		SetAlpha 0.4
		Rect DX + 1, DY + 1, W - 1, TH + 1, 1
		
		If Activ = 0 Then SetColor 50, 50, 50 SetAlpha 0.2 Rect DX + 1, DY + 1, W - 1, TH + 1, 1
		
		If Closeable = 1 Then
			SetViewport DX + 1, DY + 1, W - TextWidth("X") - 3, Gadget.TH + 1
		Else
			SetViewport DX + 1, DY + 1, W - 1, Gadget.TH + 1
		End If
		
		GuiText Text, DX + 3, DY + 2, R, G, B
		
		SetViewport 0, 0, GraphicsWidth(), GraphicsHeight()
		If Closeable = 1 Then
			SetColor 255, 0, 0
			
			If Activ = 1 Then
				If GetMouse(DX + W - TextWidth("X") - 3, DY + 2, TextWidth("X"), Gadget.TH) = 1 Then
					GuiText "X", DX + W - TextWidth("X") - 3, DY + 2, 255, 0, 0
				Else
					GuiText "X", DX + W - TextWidth("X") - 3, DY + 2, 70, 0, 0
				EndIf
			Else
				GuiText "X", DX + W - TextWidth("X") - 3, DY + 2, 70, 0, 0
			EndIf
		EndIf
		
		Local ViewX:Int = dx + 1, ViewW:Int = w - 1
		Local ViewY:Int = dy + gadget.TH + 3, ViewH:Int = h - 1 - 3 - gadget.TH
		
		SetViewport ViewX, ViewY, ViewW, ViewH
		
		For Local O:Object = EachIn Inhalt
			DrawObjekt O, ViewX, ViewY
		Next
		
		SetViewport 0, 0, GraphicsWidth(), GraphicsHeight()
		SetAlpha A
		SetColor 255, 255, 255
	End Method
	
	Method Update:Int(SX:Int = 0, SY:Int = 0)
		Local DX:Int = X + SX
		Local DY:Int = y + sy
		
		If X < 0 Then X = 0
		If Y < 0 Then Y = 0
		If X + W + 1 > GraphicsWidth() Then X = GraphicsWidth() - W - 1
		If Y + H + 1 > GraphicsHeight() Then Y = GraphicsHeight() - H - 1
		
		If Move = 0 Then
			If WinRectOver(Self, SX, SY) = 0 Then
				If Activ = 1 Then
					Local ViewX:Int = dx + 1, ViewW:Int = w - 1
					Local ViewY:Int = dy + gadget.TH + 3, ViewH:Int = h - 1 - 3 - gadget.TH
									
					For Local O:Object = EachIn Inhalt
					 	Local Get:Int = UpdateObjekt (O, ViewX, ViewY)
						If Get = 1 Then Return 1
					Next
				EndIf
			EndIf
		EndIf
		
		If MouseDown(1) Then
			If GetMouse(DX, DY, W, H) = 1 Then
				If WinRectOver(Self, SX, SY) = 0 Then
					If Activ = 1 Then
						If Move = 0 Then
							If Closeable = 1 Then
								If GetMouse(DX + W - TextWidth("X") - 3, DY + 2, TextWidth("X"), Gadget.TH) = 1 Then
									Gadget.List.Remove Self
									FlushMouse()
									Return 1
								End If
							End If
						EndIf
						
						If Move = 1 Then
							X = MouseX() - TX
							Y = MouseY() - TY
							If X < 0 Then X = 0
							If Y < 0 Then Y = 0
							If X + W + 1 > GraphicsWidth() Then X = GraphicsWidth() - W - 1
							If Y + H + 1 > GraphicsHeight() Then Y = GraphicsHeight() - H - 1
							Return 1
						End If
						
						If Move = 0 Then
							Move = 1
							TX = MouseX() - X
							TY = MouseY() - Y
							Return 1
						End If
					End If
					If Activ = 0 Then
						If IsMove() = 0 Then
							Gadget.List.Remove Self
							Gadget.List.AddLast Self
							SetActivNull
							Activ = 1
							FlushMouse()
							Return 1
						EndIf
					End If
				End If
			Else
				If Move = 1 Then
					X = MouseX() - TX
					Y = MouseY() - TY
					If X < 0 Then X = 0
					If Y < 0 Then Y = 0
					If X + W + 1 > GraphicsWidth() Then X = GraphicsWidth() - W - 1
					If Y + H + 1 > GraphicsHeight() Then Y = GraphicsHeight() - H - 1
					Return 1
				EndIf
				If Activ = 1 Then Activ = 0
			EndIf
		Else
			If Move = 1 Then Move = 0
		EndIf
	End Method
	
	Function WinRectOver:Int(Win:TWindow, SX:Int, SY:Int)
		Local G:Int = 0
		If Win = Null Then G = 1
		For Local O:Object = EachIn Gadget.List
			If TWindow(O) Then
				If G = 1 Then
					Local DX:Int
					Local DY:Int
					
					If Win <> Null Then
						DX = TWindow(O).X + SX
						DY = TWindow(O).Y + SY
					Else
						DX = SX
						DY = SY
					End If
					
					If GetMouse(DX, DY, TWindow(O).W, TWindow(O).H) = 1 Then
						Return 1
					End If
				End If
				
				If TWindow(O) = Win Then G = 1
			EndIf
		Next
	End Function
	
	Function SetActivNull()
		For Local O:Object = EachIn Gadget.List
			If TWindow(O) Then TWindow(O).Activ = 0
		Next
	End Function
	
End Type

Function IsMove:Int()
	For Local O:Object = EachIn Gadget.List
		If TWindow(O) Then
			If TWindow(O).Move = 1 Then
				Return 1
			EndIf
		EndIf
	Next
End Function

Rem
bbdoc:   Neues Fenster erstellen.  (Title:String, X:Int, Y:Int, W:Int, H:Int, CloseEnable:Int = 0)
returns: :TWindow
End Rem
Function NewWindow:TWindow (Title:String, X:Int, Y:Int, W:Int, H:Int, CloseEnable:Int = 0)
	Local Win:twindow = New twindow
	Win.X = X
	Win.Y = Y
	Win.W = W
	Win.H = H
	Win.Text = Title
	Win.Closeable = CloseEnable
	Win.Inhalt = New TList

	win.SetStandart
	Gadget.List.AddLast Win
	Return win
End Function

Function GetMouse:Int(X:Int, Y:Int, W:Int, H:Int)
	If MouseX() >= X And MouseX() <= + X + W And MouseY() >= Y And MouseY() <= Y + H Then Return 1
End Function

Function GuiText(Text:String, X:Int, Y:Int, R:Int, G:Int, B:Int)
	SetAlpha 1
	SetColor 50, 50, 50
	DrawText Text, X, Y
	SetBlend LIGHTBLEND
	SetColor R, G, B
	DrawText Text, X + 1, Y + 1
	SetBlend ALPHABLEND
End Function

Function Rect(X:Int, Y:Int, W:Int, H:Int, Fill:Int = 0)
	If Fill = 0 Then
		DrawLine X, Y, X + W, Y
		DrawLine X, Y + H, X + W, H + Y
		
		DrawLine X, Y + 1, X, H - 1 + y
		DrawLine X + W, Y + 1, X + W, H - 1 + y
	Else
		DrawRect X, Y, W, H
	EndIf
End Function

Rem
bbdoc:   Zeichnet die Gui
returns: 
End Rem
Function DrawGui()
	Gadget.TH = TextHeight("W")
	
	For Local O:Object = EachIn Gadget.List
		If TButton(O) Then TButton(O).Draw
		If TLabel(O) Then TLabel(O).Draw
		If TSlider(o) Then TSlider(o).Draw
		If TlistBox(O) Then TlistBox(O).Draw
	Next
	
	For Local O:Object = EachIn Gadget.List
		If TWindow(O) Then TWindow(O).Draw

	Next
End Function


Rem
bbdoc:   Updatet die Gui - Wenn Rückgabe=1 dann wurde etwas in der Gui getätigt.
returns: :Int
End Rem
Function UpdateGui:Int()
	Local Get:Int = 0
	Gadget.TH = TextHeight("W")
	
	If IsMove() = 0 Then
		For Local O:Object = EachIn Gadget.List
			If TButton(O) Then Get = TButton(O).Update()
			If TLabel(O) Then Get = TLabel(O).Update()
			If TSlider(O) Then Get = TSlider(O).Update()
			If TListBox(O) Then TListBox(O).Update()
			If Get = 1 Then Return 1
		Next
	EndIf
	
	For Local O:Object = EachIn Gadget.List
		If TWindow(O) Then Get = TWindow(O).Update()
		
		If Get = 1 Then Return 1
	Next
End Function

Function DrawObjekt(O:Object, X:Int, Y:Int)
	If TButton(O) Then TButton(O).Draw (X, Y)
	If TLabel(O) Then TLabel(O).Draw (X, Y)
	If TSlider(O) Then TSlider(O).Draw(X, Y)
	If TlistBox(O) Then TlistBox(O).Draw(X, Y)
End Function

Function UpdateObjekt:Int(O:Object, X:Int, Y:Int)
	Local Get:Int = 0
	If TButton(O) Then Get = TButton(O).Update (X, Y)
	If TLabel(O) Then Get = TLabel(O).Update (X, Y)
	If TSlider(O) Then Get = TSlider(O).Update (X, Y)
	If TListBox(O) Then TListBox(O).Update (X, Y)
	
	Return Get
End Function


Include "button.bmx"
Include "label.bmx"
Include "slider.bmx"
Include "listbox.bmx"